function DB() {
		var self = this;
		var db_ = null;
 
        this.init = function() {
          if (window.openDatabase) {
            db_ = openDatabase("Benzinator 001", "1.0", "Fase Release 001", 200000);
            return this;
          }
        }

		// Mostra els vehicles
		this.showVehicles = function() {
		    db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM vehicles', [], function(tx, result) {
			$('#llista_vehicles').empty();
			$('#llista_vehicles').append('<li data-role="list-divider" role="heading">Vehicles Actuals</li>');
			$.each(result.rows,function(index){
				var row = result.rows.item(index);
	
				$('#llista_vehicles').append('<li data-theme="c"><a href="#vehicle_edit" onclick="selectId('+row.id+');" data-transition="slide"><h3>'+row.nom+'</h3><p>'+row.marca+' '+row.model+'</p></a>'+
						'<a href="#popupDialog" data-rel="popup" data-position-to="window" data-role="button" data-inline="true" data-transition="pop" onclick="selectId('+row.id+');"></a></li>');
			});
		    $('#llista_vehicles').listview('refresh');
		    // Per solucionar el tema de SLIDE
		    self.CorreccionsFlickering();
	            });
	          });
	   	}
	   	
	   	this.showVehiclesLink = function(llista, txtlink, titol, img) {
	            //alert('showVehicles');
		    db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM vehicles', [], function(tx, result) {
			$(llista).empty();
			$(llista).append('<li data-role="list-divider" role="heading">'+titol+'</li>')
			$.each(result.rows,function(index){
				var row = result.rows.item(index);
	
				$(llista).append('<li data-theme="c"><a href="'+txtlink+'?id='+row.id+'" rel="external" ><img src="'+img+'" ><h3>'+row.nom+'</h3><p>'+row.marca+' '+row.model+'</p></a>'+
						'');
			});
		    $(llista).listview('refresh');
	            });
	          });
	   	}          

	   	this.showAbastiments = function(llista, txtlink, limitR) {
	        //alert('showAbastiments');
		    db_.transaction(function(tx) {
			    var limi= limitR + 1;
			    //tx.executeSql('SELECT abastiments.id, vehicles.nom, vehicles.marca, vehicles.model, abastiments.data, abastiments.import, abastiments.preulitre ' + 
	            //			  'FROM abastiments RIGHT JOIN vehicles ON abastiments.idVehicles=vehicles.id ORDER BY abastiments.data DESC LIMIT '+limitR, [], function(tx, result) {
	            //tx.executeSql('SELECT * ' + 
	            //			  'FROM abastiments ORDER BY abastiments.data DESC LIMIT '+limitR, [], function(tx, result) {
		        // Amaguem el boto de ms 25
		        $('#mes25').css('visibility', 'hidden');
				$('#mes25').show();
		        tx.executeSql('SELECT abastiments.*, vehicles.carburant, vehicles.nom, vehicles.marca, vehicles.model  ' + 
	            			  'FROM abastiments INNER JOIN vehicles ON abastiments.idvehicle=vehicles.id ORDER BY abastiments.data DESC LIMIT '+limi, [], function(tx, result) {
				$(llista).empty();
				$(llista).append('<li data-role="list-divider" role="heading">\u00DAltims Abastiments</li>');
				$.each(result.rows,function(index){
					var row = result.rows.item(index);
		
					if(index>=limitR) {
				    	$('#mes25').css('visibility', 'visible');
						$('#mes25').show();
						return false;
					}
					
					$(llista).append('<li data-theme="c"><a href="'+txtlink+'?idA='+row.id+'" rel="external" data-transition="slide">'+
						'<p style="float:right"><strong>'+data_ddmmyyyy_hhmm(row.data)+'</strong></p>	'	+
						'<h3><strong>'+row['import']+'&euro;<strong>     ('+carburant(row.carburant)+': '+row.preuLitre+' &euro;/L)</h3>'+
							'<p>'+row.nom+' '+row.marca+' '+row.model+'</p></a>'+
							'');
				});
			    $(llista).listview('refresh');
			    // Per solucionar el tema de SLIDE
		    	self.CorreccionsFlickering();
	            });
	          });
	   	}  
	   	
	   	this.showAbastiment = function(idAbastiment, mapa, marcador, botoEsborrar) {
		    db_.transaction(function(tx) {
		        tx.executeSql('SELECT * ' + 
	            			  'FROM abastiments WHERE id=? ', [idAbastiment], function(tx, result) {
					if(result.rows.length>0){				
						var row = result.rows.item(0);
						$('#km').val(row.kmactuals);
						$('#data').val(data14todata(row.data));
						$('#hora').val(data14tohora(row.data));
						$('#import').val(row['import']);
						$('#preu').val(row.preuLitre);
						$('#litres').val(row.litres);
						
						// Si hi ha una benzinera cerquem la seva posici per carregar-la al mapa:
						if(row.idBenzinera!=0){
							PosicionaBenzinera(row.idBenzinera, mapa, marcador, idAbastiment, row.idVehicle, botoEsborrar);
						} else {
							// Ara calcularem si aquest registres es pot esborrar (noms podrem esborrar l'ultim)
							verificaEsborrarAbastiment(row.idVehicle, idAbastiment, botoEsborrar);
						}
					}
	            });
	          });
	   	}
	   	

		function verificaEsborrarAbastiment(idVehicle, idAbastiment, botoEsborrar){
			// Verifiquem si estracta de l'ultim
			// select id from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=?)
			db_.transaction(function(tx) {
	            	tx.executeSql('select * from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=? )',[idVehicle,idVehicle], function(tx, result) {
		    		if(result.rows.length>0){	// Si existeix
					var row = result.rows.item(0); 
					if(row.id == idAbastiment){
						// Es l'ultim, per tant es pot esborrar/Editar:
						// Activem el bot d'esborrar
						botoEsborrar.css('visibility', 'visible');
						botoEsborrar.show();
						// I el de Salvar canvis
						$('#butCreaAbastiment').css('visibility', 'visible');
						$('#butCreaAbastiment').show();
						// Activem el bot Editar Ubicaci
						$('#butEditarUbicacio').css('visibility', 'visible');
						$('#butEditarUbicacio').show();
						// Activem el bot de Valorar
						$('#butValorar').css('visibility', 'visible');
						$('#butValorar').show();
						$('#butValorar').click(function(){db.showComentarisBenzinera(row.idBenzinera);});
						
					}	
    				}
			
	            	},self.onError);
	      		});

		}


	   	
	   	this.showVehicle = function(id) {
	            //alert('showVehicles');
		    db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM vehicles WHERE id=?',[id], function(tx, result) {
					$.each(result.rows,function(index){
						var row = result.rows.item(index);
						//alert(row.nom);
						$('#Nom').val(row['nom']);
						$('#Marca').val(row.marca)
						$('#Model').val(row['model']);
						$('#Carburant').val(row.carburant);
					});
					$('#Marca').selectmenu("refresh", true);
					$('#Carburant').selectmenu("refresh", true);
	            });
	      	});
	   	}   
	   	

		this.saltaBack = function() {
          //alert('BACK');
          
          window.location.href = "index.html#vehicles";
          
        };

		this.showRecords = function() {
          //alert('OK!!');
          
          //window.location.href = "vehicles.html";
          
        };

        this.onError = function(tx, error) {
          alert('Error: ' + error.message);
        };


        // add record 
        this.newVehicle = function() {
          	db_.transaction(function(tx) {

		  	var nom = $('#Nom').val();
		  	var marca = $('#Marca').val();
		  	var model = $('#Model').val();
		  	var carburant = $('#Carburant').val();
		  	var sincro = 0;
 
	  		tx.executeSql("INSERT INTO vehicles (nom, marca, model, carburant, sincronitzar) VALUES (?,?,?,?,?)", [nom,marca,model,carburant,sincro],
                function(tx, result) {
                  self.saltaBack();
                },
                self.onError);
          });
        };
        
        // Crea un usuari Registrat 
        this.newUsuariRegistrat = function(usr, pwd, perfil) {
          	// Esborrem els altres usuaris si hi hagues algn
	        db_.transaction(function(tx) {
				tx.executeSql("DELETE FROM usuariregistrat WHERE usuari<>?",[usr]);
	  		});
	  		// Donem d'alta un sol usuari
	  		db_.transaction(function(tx) {
				tx.executeSql("INSERT INTO usuariregistrat (usuari , password, perfil) VALUES (?,?,?)", [usr,pwd,perfil],
                	function(tx, result) {
                		return true;
                	},
                	self.onError);
          	});
        };
        
        // Tancament de sessi 
        this.TancaSessio = function() {
          	// Esborrem els usuaris
	        db_.transaction(function(tx) {
				tx.executeSql("DELETE FROM usuariregistrat",[]);
	  		});
        };
        
        this.canviPassword = function(pwd) {
	  		// Canviem el pwd
	  		db_.transaction(function(tx) {
				tx.executeSql("UPDATE usuariregistrat SET password=? ", [pwd],
                	function(tx, result) {
	                	
                		return true;
                	},
                	self.onError);
          	});
        };
        
        this.canviPerfil = function(perfil) {
	  		// Canviem el pwd
	  		db_.transaction(function(tx) {
				tx.executeSql("UPDATE usuariregistrat SET perfil=? ", [perfil],
                	function(tx, result) {
                		return true;
                	},
                	self.onError);
          	});
        };
        

        // S'encarrega de determinar si l'usuari es pot autoconectar al sistema
		this.carregaPreferencies = function(pageOnline, pageOffline) {
	        var perfil;
			db_.transaction(function(tx) {
				tx.executeSql('SELECT usuari, password FROM usuariregistrat',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var row = result.rows.item(0);
				
						$.getJSON(serviceURL + 'login.php?usuari='+row.usuari+'&pwd='+row.password+'&callback=?', function(data) {
							var resposta = data; // Reposta obtenida per JSON
							
							try{
								if(resposta.dades.usuari == row.usuari){
									// Conectats OK
									CodiUsuari = row.usuari;			// Retornem el codi d'usuari i el password
									PWDusuari = row.password;
									
									db.canviPerfil(resposta.dades.perfil);	
									
									$.mobile.changePage(pageOnline,{transition: 'none'});	// Carreguem la pagina online
								} else {
									alert('Error desconegut');
									$.mobile.changePage(pageOffline,{transition: 'none'}); 	// Carreguem la pagina offline
								}
							} catch(err) {
								// Informem que s'ha produit un error (NO indicara error de usuari o pwd)
								if(resposta == "NO") {
									alert('Error en el usuari o password');
								} else {
									alert('Error desconegut');
								}
								$.mobile.changePage(pageOffline,{transition: 'none'}); 	// Carreguem la pagina offline
							}
							
						});
						
					} else {
						$.mobile.changePage(pageOffline,{transition: 'none'});
					}
				});	 
			});	
	    };
	    
	    
	    /**********************************************************************
	    * SINCRONITZACIO DE DADES DE VEHICLES
	    *
	    **********************************************************************/
	    
	    
	    // Sincronitzacio de dades de Vehicles
		this.sincronitzarVehicles = function() {
			db_.transaction(function(tx) {
				tx.executeSql('SELECT usuari, password FROM usuariregistrat',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var row = result.rows.item(0);
						
						$('#texteSync').text('Obtenint les dades de Vehicles...');
						//PrimerEsborrem(row.usuari, row.password);
						ObtenirDadesVehicles(row.usuari, row.password);
						
						
					} else {
						//$.mobile.changePage(pageError);
						$('#texteSync').text('Cal iniciar la sessi per sincronitzar les dades.');
						$('#txtPopup1').text('Cal iniciar la sessi per sincronitzar les dades.');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				});	 
			});	
	    };
	    
	    function EsborremVehicles(usuari, pwd){
			db_.transaction(function(tx) {
				tx.executeSql('SELECT id FROM vehicles',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var llistat='';
						$.each(result.rows,function(index){
							var row = result.rows.item(index);
							
							if(llistat=='')
								llistat = row.id;
							else
								llistat = llistat + ',' + row.id;
						});
						
						EnviaEsborremVehicles(usuari, pwd, llistat);
					} else {
						// Aquest seria el cas de no haver cap vehile, per tant cal esborrar els del servidor
						// Per tant esborrerm tots menys el 0 que no existeix
						EnviaEsborremVehicles(usuari, pwd, '0');
					}
				});	 
			});  
	    }
	    
	    
	    function EnviaEsborremVehicles(usuari, pwd, llistat){
		    $.getJSON(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+'&esborra=VEHICLE&llista='+llistat+'&callback=?', function(data) {
			    var resposta = data; // Reposta obtenida per JSON
				try{
					if(resposta == "OK"){
						// Procs Finalitzat
						$('#texteSync').text('Dades Sincronitzades.');
						spinner.stop();
					} else {
						$('#texteSync').text('Error desconegut');
						$('#txtPopup1').text('Error desconegut');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				} catch(err) {
					// Informem que s'ha produit un error (NO indicara error de usuari o pwd)
					if(resposta == "NO") {
						$('#texteSync').text('Error en el usuari o password');
						$('#txtPopup1').text('Error en el usuari o password');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					} else {
						$('#texteSync').text('Error desconegut');
						$('#txtPopup1').text('Error desconegut');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				}
		    });
	    }
	    
	    function ObtenirDadesVehicles(usuari, pwd){
		    db_.transaction(function(tx) {
				tx.executeSql('SELECT * FROM vehicles WHERE sincronitzar=0',[], function(tx, result) {
					if(result.rows.length>0){	
						//alert();
						var row = result.rows.item(0);
						
						var dades = '&taula=VEHICLE&id='+row.id+'&nom='+row.nom+'&marca='+row.marca+'&model='+row.model+'&carburant='+row.carburant+'&mitjaconsum='+row.mitjaconsum;
						
						EnviaDadesVehicles(usuari, pwd, dades, row.id);
					} else {
						// Esborrem
						EsborremVehicles(usuari, pwd);
					}
				});	 
			});
	    }
	    
	    
	    
	    function EnviaDadesVehicles(usuari, pwd, dades, id){
			$('#texteSync').text('Enviant al servidor...');
			//alert(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+dades+'&callback=?');
		    $.getJSON(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+dades+'&callback=?', function(data) {
			    var resposta = data; // Reposta obtenida per JSON
				try{
					if(resposta == id){						
						// Ara marquem la dada Sincronitzada sincro = 1;	
						SincroOKVehicles(usuari,pwd,id);
						return true;
					} 
					if(resposta == "NO") {
						$('#texteSync').text('Error en el usuari o password');
						$('#txtPopup1').text('Error en el usuari o password');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
						return true;
					}
					$('#texteSync').text('Error desconegut');
					$('#txtPopup1').text('Error desconegut');			
					$('#popupDialog1').popup('open'); // Mostrem el Popup
					spinner.stop();
					
				} catch(err) {
					// Informem que s'ha produit un error
					$('#texteSync').text('Error desconegut');
					$('#txtPopup1').text('Error desconegut');			
					$('#popupDialog1').popup('open'); // Mostrem el Popup
					spinner.stop();
				}
				
			});    
	    }
	    
	    function SincroOKVehicles(usuari,pwd,id){
		    db_.transaction(function(tx) {
			    var sincro = 1;
		        tx.executeSql('UPDATE vehicles SET sincronitzar=? WHERE id = ?', [sincro, id], 
		          	function(tx, result) {
			          	// Continuem Sincronitzant
	                  	ObtenirDadesVehicles(usuari, pwd);
	                }, 
	                self.onError);
          	});
		    
	    }
	    
	    
	    /**********************************************************************
	    * SINCRONITZACIO DE DADES D'ABASTIMENTS
	    *
	    **********************************************************************/
	    
	    
	    // Sincronitzacio de dades d'Abstiments
		this.sincronitzarAbastiments = function() {
			
			db_.transaction(function(tx) {
				tx.executeSql('SELECT usuari, password FROM usuariregistrat',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var row = result.rows.item(0);
						
						$('#texteSync').text('Obtenint les dades d\'Abastiments...');

						ObtenirDadesAbastiments(row.usuari, row.password);
						
						
					} else {
						$('#texteSync').text('Cal iniciar la sessi\u00F3 per sincronitzar les dades.');
						$('#txtPopup1').text('Cal iniciar la sessi\u00F3 per sincronitzar les dades.');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				});	 
			});	
	    };
	    
	    function EsborremAbastiments(usuari, pwd){
			db_.transaction(function(tx) {
				tx.executeSql('SELECT id FROM abastiments',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var llistat='';
						$.each(result.rows,function(index){
							var row = result.rows.item(index);
							
							if(llistat=='')
								llistat = row.id;
							else
								llistat = llistat + ',' + row.id;
						});
						
						EnviaEsborremAbastiments(usuari, pwd, llistat);
					} else {
						// Aquest seria el cas de no haver cap abastiment, per tant cal esborrar els del servidor
						// Per tant esborrerm tots menys el 0 que no existeix
						EnviaEsborremAbastiments(usuari, pwd, '0');
					}
				});	 
			});  
	    }
	    
	    
	    function EnviaEsborremAbastiments(usuari, pwd, llistat){
		    $.getJSON(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+'&esborra=ABAST&llista='+llistat+'&callback=?', function(data) {
			    var resposta = data; // Reposta obtenida per JSON
				try{
					if(resposta == "OK"){
						// Procs Finalitzat
						$('#texteSync').text('Dades Sincronitzades.');
						spinner.stop();
					} else {
						$('#texteSync').text('Error desconegut');
						$('#txtPopup1').text('Error desconegut');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				} catch(err) {
					// Informem que s'ha produit un error (NO indicara error de usuari o pwd)
					if(resposta == "NO") {
						$('#texteSync').text('Error en el usuari o password');
						$('#txtPopup1').text('Error en el usuari o password');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					} else {
						$('#texteSync').text('Error desconegut');
						$('#txtPopup1').text('Error desconegut');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
					}
				}
		    });
	    }
	    
	    function ObtenirDadesAbastiments(usuari, pwd){
		    
		    db_.transaction(function(tx) {
				tx.executeSql('SELECT abastiments.*, vehicles.carburant, benzineres.latitud, benzineres.longitud  ' + 
	            			  'FROM abastiments INNER JOIN vehicles ON abastiments.idvehicle=vehicles.id ' + 
	            			  'LEFT JOIN benzineres ON abastiments.idBenzinera=benzineres.id  WHERE abastiments.sincronitzar=0' ,[], function(tx, result) {
					
					if(result.rows.length>0){	

						var row = result.rows.item(0);
						
						var lat = 999;
						var lon = 999;
						var valoracio = 0;
						var comentaris = '';
						var preulitre = 0;
						
						if(!(row.valoracio===undefined))
							valoracio = row.valoracio;
						
						if(!(row.comentari===undefined))
							comentaris = row.comentari;
							
						if(!(row.preuLitre===undefined))
							preulitre = row.preuLitre;
							
						if(row.idBenzinera!=0){
							lat = row.latitud;
							lon = row.longitud;
						}
						
						
						
						var dades = '&taula=ABAST&lat='+lat+'&lon='+lon+'&id='+row.id+'&carburant='+row.carburant+'&valoracio='+valoracio+'&comentaris='+comentaris+'&preulitre='+preulitre;
						
						EnviaDadesAbastiments(usuari, pwd, dades, row.id);
					} else {
						// Esborrem
						EsborremAbastiments(usuari, pwd);
					}
				},self.onError);	 
			});
	    }
	    
	    
	    
	    function EnviaDadesAbastiments(usuari, pwd, dades, id){
			$('#texteSync').text('Enviant al servidor...');
			//alert(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+dades+'&callback=?');
			//$('#texteSync').text(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+dades+'&callback=?');
		    $.getJSON(serviceURL + 'sync.php?usuari='+usuari+'&pwd='+pwd+dades+'&callback=?', function(data) {
			    var resposta = data; // Reposta obtenida per JSON
				try{
					if(resposta == id){						
						// Ara marquem la dada Sincronitzada sincro = 1;
						SincroOKAbastiments(usuari,pwd,id);
						return true;
					} 
					if(resposta == "NO") {
						$('#texteSync').text('Error en el usuari o password');
						$('#txtPopup1').text('Error en el usuari o password');			
						$('#popupDialog1').popup('open'); // Mostrem el Popup
						spinner.stop();
						return true;
					}
					$('#texteSync').text('Error desconegut');
					$('#txtPopup1').text('Error desconegut');			
					$('#popupDialog1').popup('open'); // Mostrem el Popup
					spinner.stop();
					
				} catch(err) {
					// Informem que s'ha produit un error
					$('#texteSync').text('Error desconegut');
					$('#txtPopup1').text('Error desconegut');			
					$('#popupDialog1').popup('open'); // Mostrem el Popup
					spinner.stop();
				}
				
			});    
	    }
	    
	    function SincroOKAbastiments(usuari,pwd,id){
		    db_.transaction(function(tx) {
			    var sincro = 1;
		        tx.executeSql('UPDATE abastiments SET sincronitzar=? WHERE id = ?', [sincro, id], 
		          	function(tx, result) {
			          	// Continuem Sincronitzant 
	                  	ObtenirDadesAbastiments(usuari, pwd);
	                }, 
	                self.onError);
          	});
		    
	    }
	    
	    /***************************************/
	    
	    /*
	    this.CalculEficiencia = function(idVehicle) {
			// Cercarem les dades necessaries de consum mitja 
			
		    db_.transaction(function(tx) {
				tx.executeSql('SELECT mitjaconsum FROM vehicles WHERE id=?',[idVehicle], function(tx, result) {
					if(result.rows.length>0){	
						var row = result.rows.item(0);
						
						MITJACONSUM = row.mitjaconsum;
						
						db.carregaPreferencies($('#benzinera'),$('#p_offline'));
						
					} else {
						alert('Error, no hi han dades disponibles');
					}
				});	 
			});
		    
		       
	    }*/
	    
	    this.populateVehicles = function(){
		 	// Cercarem les dades necessaries de consum mitja 
		 	
		    db_.transaction(function(tx) {
				tx.executeSql('SELECT id, nom , mitjaconsum FROM vehicles',[], function(tx, result) {
					if(result.rows.length>0){	
						
						var options = $("#vehicles");
						options.empty();
						$.each(result.rows,function(index){
							var row = result.rows.item(index);
						
							options.append($("<option />").val(row.mitjaconsum).text(row.nom));
						});
						
						MITJACONSUM = options.val();
						
						//db.carregaPreferencies($('#benzinera'),$('#p_offline'));
						
						//self.CalculEficiencia(options.val());
						
							
					} else {
						//alert('Error, no hi han dades disponibles');
					}
				});	 
			});
		    
	    }
	    
	    
	    
	    this.carregaPerfil = function() {
	        
			db_.transaction(function(tx) {
				tx.executeSql('SELECT perfil FROM usuariregistrat',[], function(tx, result) {
					if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
						var row = result.rows.item(0);
						if(row.perfil==1){ $('#optPRIVAT').attr('checked', true);$('#optPRIVAT').checkboxradio("refresh");}
						if(row.perfil==2){ $('#optAMICS').attr('checked', true);$('#optAMICS').checkboxradio("refresh");}
						if(row.perfil==3){ $('#optFULL').attr('checked', true);$('#optFULL').checkboxradio("refresh");}
						if(row.perfil==null){ $('#optPRIVAT').attr('checked', false);$('#optoptPRIVATFULL').checkboxradio("refresh");
											$('#optAMICS').attr('checked', false);$('#optAMICS').checkboxradio("refresh");
											$('#optFULL').attr('checked', false);$('#optFULL').checkboxradio("refresh");}
					} else {
						alert('L\u00B4usuari no disposa de perfil. Cal iniciar la sessi\u00F3.');
					}
				});	 
			});	
				
	    };
        
	    
	    
	    
	    
	    
        
        this.updateVehicle = function(id) {
          db_.transaction(function(tx) {
            var nom = $('#Nom').val();
		  	var marca = $('#Marca').val();
		  	var model = $('#Model').val();
		  	var carburant = $('#Carburant').val();
		  	var sincro = 0;
	        //alert(id+' '+nom+' '+marca+' '+model+' '+carburant+' '+sincro);
	        tx.executeSql('UPDATE vehicles SET nom=?, marca=?, model=?, carburant=?, sincronitzar=? WHERE id = ?', [nom,marca,model,carburant,sincro, id], 
	          	function(tx, result) {
                  self.saltaBack();
                }, 
                self.onError);
          });
        };

        this.deleteVehicle = function(id) {
            //alert(id);
	    db_.transaction(function(tx) {
            	tx.executeSql("DELETE FROM vehicles WHERE id=?", [id],
                	function(tx, result) { self.showVehicles(); }, self.onError);
          });
        };
        

	// Cerca dades pel Grafic de consum
	this.ConsultaConsum = function(idVehicle,tipus) {
		db_.transaction(function(tx) {
			// Per tal de solucionar un problema quan les dates sn molt prximes es fa una mitja del dia i hora
	    	tx.executeSql('SELECT AVG(dConsum) as dC, AVG(dCostConsum) as dCC, MAX(data) as fecha FROM abastiments WHERE idVehicle=? AND dDies>0 GROUP BY SUBSTR(abastiments.data,1,10) ', [idVehicle], function(tx, result) {
				
		    	if(result.rows.length<2) {
			    	// Si no hi han dades si no tenim abastiment o noms tenim 1, o els abastiments sn molt prxims
			    	$('#buit').text('No hi han suficients dades');
			    	return true;	
		    	}
		    	
		    	var t = [];
					
				$.each(result.rows,function(index){
					var row = result.rows.item(index);
					if(tipus=='L'){	// Consum en L/100km
						t.push([data14todata(row.fecha) + ' ' + data14tohora2(row.fecha),row.dC]);	
					}else{ 			// Cost del consum en km/
						t.push([data14todata(row.fecha) + ' ' + data14tohora2(row.fecha),row.dCC]);
					}		
				});
				// Reenviem el resultat per plotejar
				Plotea(t,tipus);
		    },
		    self.onError);
		});
	}

	function Plotea(dades, tipus){
		// Carreguem les dades
		//alert(dades);
		//var dades=[['2008-08-12 14:00PM',4], ['2008-08-12 14:00PM',6.5]];
	  	var titol = '';
		if(tipus=='L') {titol='Consum en L/100km';}
	  	if(tipus=='E') {titol='Cost en km/euro';}
		
	  	var destiPlot='';
	  	
	  	destiPlot = $.jqplot('chart1', [dades], {
		    title: titol,
		    axes:{
		        xaxis:{tickOptions:{formatString:"%#d/%#m/%y"},
		            renderer:$.jqplot.DateAxisRenderer
		        }
		    },
		    series:[{lineWidth:4}]
	  	});
	  	
	  	destiPlot.replot();
	  	plot1 = destiPlot;
	}
	

        
	// Afegeix la informaci d'un abastiment
	this.newAbastiment = function(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data, hora) {     	
		// Primer verificarem que totes les dades siguin correctes	        
		VerificaAbastiment(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data, hora);	
  	};

	
       	// Verificaci de les dades del abastiment
	function VerificaAbastiment(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,datap, horap){
		// CONDICIONS
		// La nova data no pot ser inferior o igual a cap data existent del mateix vehicle
		// Els nous Km no poden ser inferiors.

		var data = datahora14(datap, horap); // Converteix la hora al format correcte

		db_.transaction(function(tx) {
			tx.executeSql('SELECT * FROM abastiments WHERE idVehicle=? AND (kmactuals>? OR data>=?) ',[idVehicle,km,data], function(tx, result) {
			if(result.rows.length>0){	// Si trobem alguna les dades proporcionades sn incorrectes
				var row = result.rows.item(0);
				var t='';
				// Mirem si es tracta dels km, la data o ambdos:
				if(row.kmactuals>km){t=t+'km';}
				if(row.data>=data){if(t!=''){t=t+' i ';}t=t+'data';}

				// Ara preparem el texte per mostrar per pantalla amb l'error:
				$('#txtPopup').text('Els valors de '+t+' proporcionats no s\u00F3n correctes');			
				$('#popupDialog').popup('open'); // Mostrem el Popup

			}else{ 
				// Si no hi ha cap podem continuar
				// Verifiquem ara la posici GPS per la benzinera
				if(lat!=999){ // 999 indica que no s'ha especificat la posici de la benzinera per tant ID=0
	        			CercaBenzinera(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,datap,horap);
  				}
  				else{
	  				AltaAbastiment(idVehicle, 0, km,litres,preu,importEuros,datap,horap);
  				}
			}
	            },self.onError);
	      	});

	}

	// Verifica que l'abastiment es pot esborrar i l'esborra (calcula previament el idVehicle)
	this.esborrarAbastiment = function(idAbastiment){
		// Primer obtindrem el idVehicle del Abastiment:
		db_.transaction(function(tx) {
            tx.executeSql('select idVehicle from abastiments where id=?',[idAbastiment], function(tx, result) {
	            if(result.rows.length>0){	// Si existeix
					var row = result.rows.item(0); 
					// Ara verificarem si es pot esborrar
					verificaYesborra(idAbastiment, row.idVehicle)
				}
           	},self.onError);
      	});	
		
	}

	// Verifica que l'abastiment es pos esborrat i l'esborra
	function verificaYesborra(idAbastiment, idVehicle){
		db_.transaction(function(tx) {
            tx.executeSql('select * from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=? )',[idVehicle,idVehicle], function(tx, result) {
	    		if(result.rows.length>0){	// Si existeix
					var row = result.rows.item(0); 
					if(row.id == idAbastiment){
						// Es l'ultim, per tant es pot esborrar:
						esborraAbastiment(idAbastiment);
					}	
				}
           	},self.onError);
      	});	
	}
	
	
	// Esborra el abastiment amb ID=id (S'ha verificat previament)
	function esborraAbastiment(id) {
		db_.transaction(
			function(tx) {
				tx.executeSql("DELETE FROM abastiments WHERE id=?",[id],
  				function(tx, result) {
					$.mobile.changePage('#esborratok');
				}, 
  				self.onError );
  		});		
	}
    
        // Cerca una benzinera
        function CercaBenzinera(idVehicle,lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data,hora) {
          	// Calcularem una posici aproximada de +-50 metros
		// El metode est extret de la aproximaci d'un grau en km tenint en compte el radi de la Terra
	        var lat1 = lat-0.000449;
          	var lat2 = lat+0.000449;
          	
          	var lon1 = lon-0.000449;
          	var lon2 = lon+0.000449;

	        db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM benzineres WHERE latitud>? AND latitud<? AND longitud>? AND longitud<? ',[lat1,lat2,lon1,lon2], function(tx, result) {
		            if(result.rows.length>0){	// Si trobem alguna
						var row = result.rows.item(0);
						AltaAbastiment(idVehicle, row.id, km,litres,preu,importEuros,data,hora); // Donem d'alta l'abastiment per aquesta benzinera
					}else{ // si no caldra crear una benzinera
						CreaBenzinera(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data,hora);
					}
	            },self.onError);
	      	});
        }

	// Update en dades de l'abastiment
	this.SalvaCanvisAbastiment = function(idAbastiment,lat,lon,comentari,valora,km,litres,preu,importEuros,data, hora){
		// Verifiquem que s'estigui editant l'ultim:
		db_.transaction(function(tx) {
			tx.executeSql('select * from abastiments where idVehicle=(select idVehicle WHERE id=?) AND data=(select max(data) from abastiments where idVehicle=(select idVehicle WHERE id=?))',[idAbastiment,idAbastiment], function(tx, result) {
				if(result.rows.length>0){	
					var row = result.rows.item(0);
					// Cal que sigui el mateix ID
					if(idAbastiment == row.id){
						// Es possible editar perque es l'ultim, ara es mira si la benzinera es correcta:
						VerificaEdicioBenzinera(idAbastiment,row.idVehicle,lat,lon,comentari,valora,km,litres,preu,importEuros,data, hora);
					} else {
						// Ara preparem el texte per mostrar per pantalla amb l'error:
						$('#txtPopup').text('No s lltim abastiment. No pot ser modificat');			
						$('#popupDialog').popup('open'); // Mostrem el Popup
						return false;
					}
				}
			},self.onError);
		});
	}


	function VerificaEdicioBenzinera(idAbastiment,idVehicle,lat,lon,comentari,valora,km,litres,preu,importEuros,data, hora){
		if(lat==999){
			// En cas de ser 999 indica que no hi ha cap benzinera, aix que passem a editar
			verificaPosibleEditaryEdita(idAbastiment,idVehicle, 0 ,comentari,valora,km,litres,preu,importEuros,data, hora);
			return true;	
		}
		
		
		// Calcularem una posici aproximada de +-50 metros
		// El metode est extret de la aproximaci d'un grau en km tenint en compte el radi de la Terra
	        var lat1 = lat-0.000449;
          	var lat2 = lat+0.000449;
          	
          	var lon1 = lon-0.000449;
          	var lon2 = lon+0.000449;
	        
	        db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM benzineres WHERE latitud>? AND latitud<? AND longitud>? AND longitud<? ',[lat1,lat2,lon1,lon2], function(tx, result) {
		            if(result.rows.length>0){	// Si trobem alguna
						var row = result.rows.item(0);
						// S'ha trobat una benzinera (usem el seu ID)
						verificaPosibleEditaryEdita(idAbastiment,idVehicle, row.id ,comentari,valora,km,litres,preu,importEuros,data, hora);
					}else{ // si no caldra crear una benzinera
						CreaBenzinera2(idAbastiment,idVehicle,lat,lon,comentari,valora,km,litres,preu,importEuros,data,hora);
					}
	            },self.onError);
	      	});
}



	// Verifica que les dades siguin correctes y les edita en cas afirmatiu
	function verificaPosibleEditaryEdita(idAbastiment,idVehicle,idBenzinera,comentari,valora,km,litres,preu,importEuros,datap, horap){
		// Busquem l'anterior a aquest
		db_.transaction(function(tx) {
			tx.executeSql('select * from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=? and id<>?)',[idVehicle,idVehicle,idAbastiment], function(tx, result) {
				
			if(result.rows.length>0){	// Si trobem dades hem de calcular dels deltes de consum, km,...
				var row = result.rows.item(0);
				var data = datahora14(datap, horap); 	// Converteix la hora al format correcte
				
				// Verifiquem la coherencia de km y data:
				if(row.kmactuals>km || row.data>=data){
					var t='';
					// Mirem si es tracta dels km, la data o ambdos:
					if(row.kmactuals>km){t=t+'km';}
					if(row.data>=data){if(t!=''){t=t+' i ';}t=t+'data';}

					// Ara preparem el texte per mostrar per pantalla amb l'error:
					$('#txtPopup').text('Els valors de '+t+' proporcionats no s\u00F3n correctes');			
					$('#popupDialog').popup('open'); // Mostrem el Popup
					return false;	
				}

				var dDies = DifSeg(data, row.data); 	// Diferencia en segons des del ultim abastiment
				var dKm; 								// km realitzats respecte l'ultim abastiment
				var dConsum; 							// Consum en L/100km respecte l'ulti abastiment
				var dCostConsum;						// Cost en km/ respecte el ltim abastiments
				
				// Fem els calculs
				dKm = km - row.kmactuals;				// km actuals - km anteriors (kmactuals fa referencia a l'ultim abastiment)
				
				dConsum = row.litres / dKm * 100;		// litres de l'ultim abastiment / km realitzats * 100 = L/100km
				
				dCostConsum = dKm / row['import'];			// Km realitzats / cost en eruros del ultim abastiment = km/

				// Ara donem d'alta l'abastiment amb les dades
				EditaAbastiment(idAbastiment, idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, dDies, dKm, dConsum, dCostConsum,comentari,valora)

			}else{ 
				// Si no hi ha cap es tracta del primer abastiment, per tant els deltes seran 0
				EditaAbastiment(idAbastiment, idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, 0, 0, 0, 0,'','',comentari,valora)
			}
	
			},self.onError);
		});
}

	// EDITEM LES DADES DE L'ABASTIMENT
	function EditaAbastiment(idAbastiment, idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, dDies, dKm, dConsum, dCostConsum, comentari,valora){
		db_.transaction(function(tx) {
			
			var data = datahora14(datap, horap); // Converteix la hora al format correcte
			var sincro = 0;
			// FEM EL UPDATE
			tx.executeSql("UPDATE abastiments SET idBenzinera=?, kmactuals=?, litres=?, preuLitre=?, import=?, data=?, dDies=?, dKM=?, dConsum=?, dCostConsum=?, sincronitzar=? WHERE id=?", 
	  				[idBenzinera,km,litres,preu,importEuros,data,dDies, dKm, dConsum, dCostConsum, sincro,idAbastiment],
                	function(tx, result) {
	                	// Ara llanem la actualitzaci de comentaris de la benzinera si existeixen:
	                	EditaBenzinera(idBenzinera, comentari,valora);
	                	// Arribats aqui hem acabat i mostrem la pantalla OK
                  		$.mobile.changePage('#pantallaok');
                	},
                	self.onError);
          	});
	}

	// EDITEM ELS COMENTARIS DE LA BENZINERA
	function EditaBenzinera(idBenzinera, comentari,valora){
		if(idBenzinera>0){
		db_.transaction(function(tx) {

			// FEM EL UPDATE
			tx.executeSql("UPDATE benzineres SET valoracio=?, comentari=? WHERE id=?", 
	  				[valora,comentari,idBenzinera],
                	function(tx, result) {
	                	return true;
                	},
                	self.onError);
          	});
		}
	}
	
	
        
	// Salva l'abastiment
	function AltaAbastiment(idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap){
		//select * from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=?)

		db_.transaction(function(tx) {
	    	// Busquem l'ultim abastiment del vehicle
			tx.executeSql('select * from abastiments where idVehicle=? AND data=(select max(data) from abastiments where idVehicle=?)',[idVehicle,idVehicle], function(tx, result) {
			if(result.rows.length>0){	// Si trobem dades hem de calcular dels deltes de consum, km,...
				var row = result.rows.item(0);
				
				var data = datahora14(datap, horap); 	// Converteix la hora al format correcte
				
				var dDies = DifSeg(data, row.data); 	// Diferencia en segons des del ultim abastiment
				var dKm; 								// km realitzats respecte l'ultim abastiment
				var dConsum; 							// Consum en L/100km respecte l'ulti abastiment
				var dCostConsum;						// Cost en km/ respecte el ltim abastiments
				
				// Fem els calculs
				dKm = km - row.kmactuals;				// km actuals - km anteriors (kmactuals fa referencia a l'ultim abastiment)
				
				dConsum = row.litres / dKm * 100;		// litres de l'ultim abastiment / km realitzats * 100 = L/100km
				
				dCostConsum = dKm / row['import'];			// Km realitzats / cost en eruros del ultim abastiment = km/

				// Ara donem d'alta l'abastiment amb les dades
				CreaAbastiment(idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, dDies, dKm, dConsum, dCostConsum)

			}else{ 
				// Si no hi ha cap es tracta del primer abastiment, per tant els deltes seran 0
				CreaAbastiment(idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, 0, 0, 0, 0)
			}
	            },self.onError);
	      	});	        
		
      }
      
    // Diferencia entre les 2 dates
    // format 14 = YYYYMMDDHHNNSS
 	function DifSeg(data1, data2){
	 	var d1 = ConvFecha(data1);
	 	var d2 = ConvFecha(data2);
	 	return (d1-d2)/(1000);	// 1000 milisegons per passar a segons
 	}
       
 	
 	function ConvFecha(data14){
		// Seguint javascritpt:
	 	// var d = new Date(year, month, day, hours, minutes, seconds, milliseconds);
	 	return new Date(data14.substr(0,4),data14.substr(4,2),data14.substr(6,2),data14.substr(8,2),data14.substr(10,2),data14.substr(12,2),0); 	
 	}

	function CreaAbastiment(idVehicle, idBenzinera, km,litres,preu,importEuros,datap, horap, dDies, dKm, dConsum, dCostConsum){
		db_.transaction(function(tx) {
			
			var data = datahora14(datap, horap); // Converteix la hora al format correcte
			var sincro = 0;

			tx.executeSql("INSERT INTO abastiments (idVehicle, idBenzinera, kmactuals, litres, preuLitre, import, data, dDies, dKM, dConsum, dCostConsum, sincronitzar) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)", 
	  					 [idVehicle,idBenzinera,km,litres,preu,importEuros,data,dDies, dKm, dConsum, dCostConsum, sincro],
                	function(tx, result) {
	                	// Ara actualitzem les dades de cosum mitja i kilometres

	                	actualitzaVehicle(idVehicle);
                	},
                	self.onError);
          	});

	}
	
	function actualitzaVehicle(idVehicle){
		db_.transaction(function(tx) {
            tx.executeSql('SELECT sum(litres) as l, sum(dKM) as k FROM abastiments WHERE idVehicle=? ',[idVehicle], function(tx, result) {
	            if(result.rows.length>0){	// Si trobem algun
	            
	            	var row = result.rows.item(0);
					
					updateConsumVehicle(idVehicle, row['k'], row['l']);
					
				} else {
					$.mobile.changePage('#pantallaok');	
				}
				
            },self.onError);
      	});
    }
    
    function updateConsumVehicle(idVehicle, km, litres) {
	    
		db_.transaction(function(tx) {
			
			var sincro = 0;
			var mitja=0;
			if(km>0){
				mitja = litres/km*100;
			}
						
			tx.executeSql('UPDATE vehicles SET kilometres=?, mitjaconsum=?, sincronitzar=? WHERE id = ?', [ km, mitja,sincro, idVehicle], 
				function(tx, result) {
					// Hem acabat correctament
					$.mobile.changePage('#pantallaok');	
				}, 
				self.onError);
		});
	}
    
	
	
        
    // Afegeix una benzinera y continua el alta de l'abastiment
    function CreaBenzinera(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data,hora) {
      	db_.transaction(function(tx) {

			var alt = 0;	// 0 per defecte
	          	 
	  		tx.executeSql("INSERT INTO benzineres (longitud, latitud, altitud, valoracio, comentari ) VALUES (?,?,?,?,?)", 
	  					 [lon,lat,alt,valoracio,comentaris],
	            function(tx, result) {
			//alert(result.insertId);
			AltaAbastiment(idVehicle, result.insertId, km,litres,preu,importEuros,data,hora); // Donem d'alta l'abastiment per aquesta benzinera
                //CercaBenzinera(idVehicle, lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data,hora);
		},
            	self.onError);
      });
    }

    // Afegeix una benzinera y continua la edici de l'abastiment
    function CreaBenzinera2(idAbastiment,idVehicle,lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data,hora) {
      	db_.transaction(function(tx) {

			var alt = 0;	// 0 per defecte
	          	 
	  		tx.executeSql("INSERT INTO benzineres (longitud, latitud, altitud, valoracio, comentari) VALUES (?,?,?,?,?)", 
	  					 [lon,lat,alt,valoracio,comentaris],
	            function(tx, result) {
			// Continuem amb la edici de l'abastiment, retornant a la rutina on es cerca (ara ja existir)
			VerificaEdicioBenzinera(idAbastiment,idVehicle,lat,lon,comentaris,valoracio,km,litres,preu,importEuros,data, hora)
		},
            	self.onError);
      });
    }
    

	// Cerca una benzinera
        function PosicionaBenzinera(id, mapa, marcador,idAbastiment, idVehicle, botoEsborrar) {
	        db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM benzineres WHERE id=? ',[id], function(tx, result) {
		    	if(result.rows.length>0){	// Si la trobem 
					var row = result.rows.item(0);
					lat = row.latitud; lon = row.longitud;
					
					// Posicionem la benzinera al mapa
					var position = new google.maps.LatLng(row.latitud,row.longitud);
					// Centrem el mapa a la posicio
					mapa.panTo(position);
					// Utilitzem el marcador per tal de apuntar a la posici
					if(marcador!=''){ 
		      				marcador.setPosition(position);
	    				}else{  
		  				marcador = new google.maps.Marker({
	          					position: position,
	          					map: mapa
	        				});
    				}
		
			}
			verificaEsborrarAbastiment(idVehicle, idAbastiment, botoEsborrar);
	            },self.onError);
	      	});
        }


        // Mostra la valoracio i comentaris d'una benzinera
        this.showComentarisBenzinera = function(id) {
	        db_.transaction(function(tx) {
	            tx.executeSql('SELECT * FROM benzineres WHERE id=? ',[id], function(tx, result) {
		    	if(result.rows.length>0){	// Si la trobem 
					var row = result.rows.item(0);
					// Posicionem la benzinera al mapa
					/*var position = new google.maps.LatLng(row.latitud,row.longitud);
					// Centrem el mapa a la posicio
					mapa.panTo(position);
					// Utilitzem el marcador per tal de apuntar a la posici
					if(marcador!=''){ 
		      				marcador.setPosition(position);
	    				}else{  
		  				marcador = new google.maps.Marker({
	          					position: position,
	          					map: mapa
	        				});
    				}*/
    				$('#comentaris').val(row.comentari);
    				// Ara carreguem les estrelles de la valoraci:	
    				if(row.valoracio>0 && row.valoracio<6){
	    				$('#valoraciostars').rateit('value', row.valoracio);
    				}
    				valora = row.valoracio;
				}
	            },self.onError);
	      	});
        }
        
        
        
  	function data14todata(data){
		return data.substr(0,4)+'-'+data.substr(4,2)+'-'+data.substr(6,2); 
	}
        
	function data14tohora(data){
		return data.substr(8,2)+':'+data.substr(10,2)+':'+data.substr(12,2);
	}
       
	function data14tohora2(data){
		return data.substr(8,2)+':'+data.substr(10,2);
	}
	 
        function datahora14(data, hora){
	     
	        return data.replace(/-/g,'')+hora.replace(/:/g,'');   
        }
        
        function data_ddmmyyyy(data){
	        return data.substr(5,2)+'/'+data.substr(3,2)+'/'+data.substr(1,4);   
        }
        
        function data_ddmmyyyy_hhmm(data){
	        return data.substr(6,2)+'/'+data.substr(4,2)+'/'+data.substr(0,4)+' '+data.substr(8,2)+':'+data.substr(10,2);   
        }
        
        this.data_yyyymmdd = function(fecha){
        	var twoDigitMonth = (fecha.getMonth()+1)+''; if(twoDigitMonth.length==1){ twoDigitMonth = '0' + twoDigitMonth;}
			var twoDigitDate = fecha.getDate()+''; if(twoDigitDate.length==1){twoDigitDate='0' + twoDigitDate;}
			var currentDate = fecha.getFullYear() + '-' + twoDigitMonth + '-' + twoDigitDate;
			
			return currentDate;
	    };
	    
	    
	    this.data_hhmmss = function(fecha){
        	var twoDigitHours = fecha.getHours()+''; if(twoDigitHours.length==1){ twoDigitHours = '0' + twoDigitHours;}
			var twoDigitMis = fecha.getMinutes()+''; if(twoDigitMis.length==1){twoDigitMis='0' + twoDigitMis;}
			var twoDigitSecs = fecha.getSeconds()+''; if(twoDigitSecs.length==1){twoDigitSecs='0' + twoDigitSecs;}
			var currentTime = twoDigitHours + ':' + twoDigitMis + ':' + twoDigitSecs;
			
			return currentTime;
	    }
        
        function carburant(idCarburant){
	        switch(idCarburant){
		        case 1: return "Diesel";
		        break;
		        case 2: return "Diesel Plus";
		        break;
		        case 3: return "Sense Plom 95";
		        break;
		        case 4: return "Sense Plom 98";
		        break;
	        }
        }
        
        

    	// Creaci de les taules SQLite segons Diagrama de Dades
		this.createTables = function() {
          db_.transaction(function(tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS usuariregistrat (usuari TEXT NOT NULL PRIMARY KEY, password TEXT NOT NULL, perfil INTEGER)', [],
                function(tx) {  },
                self.onError);
	        tx.executeSql('CREATE TABLE IF NOT EXISTS vehicles (id INTEGER PRIMARY KEY AUTOINCREMENT, nom TEXT NOT NULL, marca TEXT NOT NULL, model TEXT NOT NULL, carburant INTEGER, kilometres INTEGER, mitjaconsum REAL, sincronitzar INTEGER)', [],
                function(tx) {  },
                self.onError);
           	tx.executeSql('CREATE TABLE IF NOT EXISTS abastiments (id INTEGER PRIMARY KEY AUTOINCREMENT, idVehicle INTEGER, idBenzinera INTEGER, kmactuals INTEGER, litres REAL, preuLitre REAL, import REAL, data TEXT NOT NULL, dDies INTEGER, dKM INTEGER, dConsum REAL, dCostConsum REAL, sincronitzar INTEGER)', [],
                function(tx) {  },
                self.onError);
            tx.executeSql('CREATE TABLE IF NOT EXISTS benzineres (id INTEGER PRIMARY KEY AUTOINCREMENT, latitud REAL, longitud REAL, altitud REAL, valoracio INTEGER, comentari TEXT NOT NULL)', [],
                function(tx) {  },
                self.onError);
          });
        };

        // Carrega les marques
        this.cargaMarcas = function(selector) {
		   	// Les carreguem com un array
	        var data = ['Alfa Romeo', 'Aston Martin', 'Audi', 'Autovaz', 'Bentley', 'Bmw', 'Cadillac', 'Caterham', 'Chevrolet', 'Chrysler', 'Citroen', 'Daihatsu', 'Dodge', 
						'Ferrari', 'Fiat', 'Ford', 'Honda', 'Hummer', 'Hyundai', 'Isuzu', 'Jaguar', 'Jeep', 'Kia', 'Lamborghini', 'Lancia', 'Land Rover', 'Lexus', 'Lotus', 
						'Maserati', 'Mazda', 'Mercedes Benz', 'MG', 'Mini', 'Mitsubishi', 'Morgan', 'Nissan', 'Opel', 'Peugeot', 'Porsche', 'Renault', 'Rolls Royce', 'Rover', 
						'Saab', 'Seat', 'Skoda', 'Smart', 'Ssangyong', 'Subaru', 'Suzuki', 'Tata', 'Toyota', 'Volkswagen', 'Volvo'];
			var $select = $(selector); 
			$select.empty();
			for (var i = 0; i < data.length; i++) {
			    var o = $('<option/>', { value: data[i] })
			        .text(data[i])
			        .prop('selected', i == 0);
			    o.appendTo($select);
			}
		}
		
		// Carrega les marques amb * per totes
        this.cargaMarcasQ = function(selector) {
		   	// Les carreguem com un array
	        var data = ['* Qualsevol', 'Alfa Romeo', 'Aston Martin', 'Audi', 'Autovaz', 'Bentley', 'Bmw', 'Cadillac', 'Caterham', 'Chevrolet', 'Chrysler', 'Citroen', 'Daihatsu', 'Dodge', 
						'Ferrari', 'Fiat', 'Ford', 'Honda', 'Hummer', 'Hyundai', 'Isuzu', 'Jaguar', 'Jeep', 'Kia', 'Lamborghini', 'Lancia', 'Land Rover', 'Lexus', 'Lotus', 
						'Maserati', 'Mazda', 'Mercedes Benz', 'MG', 'Mini', 'Mitsubishi', 'Morgan', 'Nissan', 'Opel', 'Peugeot', 'Porsche', 'Renault', 'Rolls Royce', 'Rover', 
						'Saab', 'Seat', 'Skoda', 'Smart', 'Ssangyong', 'Subaru', 'Suzuki', 'Tata', 'Toyota', 'Volkswagen', 'Volvo'];
			var $select = $(selector); 
			$select.empty();
			for (var i = 0; i < data.length; i++) {
			    var o = $('<option/>', { value: data[i] })
			        .text(data[i])
			        .prop('selected', i == 0);
			    o.appendTo($select);
			}
		}
		
		// Correccions per tal d'evitar el Flickering en Android i iOS
		this.CorreccionsFlickering = function() {
			$.mobile.buttonMarkup.hoverDelay=0;
			if (navigator.userAgent.indexOf("Android") != -1)
		    {
		        $.mobile.defaultPageTransition = 'none';
		        $.mobile.defaultDialogTransition = 'none';
		        $.each($('[data-transition="slide"]'), function (index, value) {
			        $(value).attr('data-transition', 'none');
			    });
		    }
		    else {
			    $.mobile.defaultPageTransition = 'none';
		        $.mobile.defaultDialogTransition = 'pop';
		        $.each($('[data-transition="none"]'), function (index, value) {
			        $(value).attr('data-transition', 'slide');
			    });
		    }	
		}
		
		this.CorreccioTermesGoogle = function(IDmap) {
			// En cas de Android cal arreglar el fet que els termes d'us s'obren en el mateix Webview i no es pot sortir
			if (navigator.userAgent.indexOf("Android") != -1)
		    {
				// La linea a eliminar es:
				// <a style="color: rgb(68, 68, 68); text-decoration: underline; cursor: pointer;" href="http://www.google.com/intl/es-ES_US/help/terms_maps.html" target="_blank">Trminos de uso</a>	
			    google.maps.event.addListenerOnce(IDmap, 'tilesloaded', function(){
					// Eliminem el HREF que apunta als termes de us de google
					$.each($('a[href*="www.google.com/"]'), function (index, value) {
			        	// Substituint-la per ''
						$(value).attr('href', '');
			    	});
			    });	
		    }
		}

      

};
var db = (new DB()).init();

/*******************************************
* CONFIGURACI DE LA CONNEXIO JSON
*
*******************************************/
// Direcci LOCAL
//var serviceURL = "http://localhost/";
// Direcci REMOTA EN AMAZON EC2
var serviceURL = "http://ec2-23-20-53-72.compute-1.amazonaws.com/";


// SPINNER
var optsSpinner = {
  lines: 13, // The number of lines to draw
  length: 7, // The length of each line
  width: 4, // The line thickness
  radius: 10, // The radius of the inner circle
  corners: 1, // Corner roundness (0..1)
  rotate: 0, // The rotation offset
  color: '#000', // #rgb or #rrggbb
  speed: 1, // Rounds per second
  trail: 60, // Afterglow percentage
  shadow: false, // Whether to render a shadow
  hwaccel: false, // Whether to use hardware acceleration
  className: 'spinner', // The CSS class to assign to the spinner
  zIndex: 2e9, // The z-index (defaults to 2000000000)
  top: 'auto', // Top position relative to parent in px
  left: '50' // Left position relative to parent in px
};