<?php
include 'config.php';

if($_GET[usuari]=='' || $_GET[pwd]==''){echo $_GET['callback'].'('.json_encode('ERROR').')';return 0; }

$sql = "select usuari from benzinator.usuariregistrat where usuari=:usuari AND password=:pwd";

try {
	$dbh = new PDO("mysql:host=$dbhost;dbname=$dbname", $dbuser, $dbpass);	
	$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$stmt = $dbh->prepare($sql);  
	$stmt->bindParam("usuari", $_GET[usuari]);
	$stmt->bindParam("pwd", $_GET[pwd]);
	$stmt->execute();
	$conta = $stmt->rowCount();
	if($conta == 0){
		echo $_GET['callback'].'('.json_encode('NO').')';
		return 0;
	} 
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR').')';
	return 0; 
}
// Primer el DELETE
if($_GET[del]!=''){
	$sql = "delete from benzinator.amics WHERE usuari=:usuari AND amic=:amic";
	
	try {
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("amic", $_GET[del]);  
		$stmt->execute();
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERROR').')';  
		return 0;
	}
}
// DESPRES EL ADD
if($_GET[add]!=''){
	$sql = "insert ignore into benzinator.amics (usuari, amic) VALUES(:usuari, :amic)";
	
	try {
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("amic", $_GET[add]);   
		$stmt->execute();
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERROR').')';
		return 0;  
	}
}
// PER ULTIM LLISTEM
$sql = "select amic from benzinator.amics WHERE usuari=:usuari";

try {
	$stmt = $dbh->prepare($sql);
	$stmt->bindParam("usuari", $_GET[usuari]);  
	$stmt->execute();
	$amics = $stmt->fetchAll(PDO::FETCH_OBJ);
	$dbh = null;
	echo $_GET['callback'].'({"amics":'. json_encode($amics).'})';
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR').')'; 
}

?>