<?php
include 'config.php';

if($_GET[usuari]=='' || $_GET[pwd]==''){echo $_GET['callback'].'('.json_encode('ERROR').')';return 0; }

$sql = "select usuari from benzinator.usuariregistrat where usuari=:usuari AND password=:pwd";

try {
	$dbh = new PDO("mysql:host=$dbhost;dbname=$dbname", $dbuser, $dbpass);	
	$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$stmt = $dbh->prepare($sql);  
	$stmt->bindParam("usuari", $_GET[usuari]);
	$stmt->bindParam("pwd", $_GET[pwd]);
	$stmt->execute();
	$conta = $stmt->rowCount();
	if($conta == 0){
		echo $_GET['callback'].'('.json_encode('NO').')';
		return 0;
	} 
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR').')';
	return 0; 
}

$perfil = 0; // Sense accs

// Primer busquem el perfil de l'usuari
$sql = "select perfil from benzinator.usuariregistrat WHERE usuari=:usuari ";

try {
	$stmt = $dbh->prepare($sql);  
	$stmt->bindParam("usuari", $_GET[usuari]);
	$stmt->execute();
	// Obtenim el perfil
	$row = $stmt->fetch(PDO::FETCH_ASSOC);
	$perfil = $row['perfil'];
	//echo $_GET['callback'].'2('.json_encode($perfil).')';return 0;
	
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR1').')';
	//echo $e->getMessage();
	return 0; 
}

if($perfil<2) {
		echo $_GET['callback'].'('.json_encode('PERFIL').')';
		return 0; 
}

$sql = "select usuari from benzinator.amics WHERE amic=:usuari ";
$llista = "'".$_GET[usuari]."'";
try {
	$stmt = $dbh->prepare($sql);  
	$stmt->bindParam("usuari", $_GET[usuari]);
	$stmt->execute();
	$conta = $stmt->rowCount();
	
	if($conta != 0){
		// Obtenim el perfil
		//$row = $stmt->fetch(PDO::FETCH_ASSOC);
		//$llista="'".$row['usuari']."'";
		while($row = $stmt->fetch(PDO::FETCH_ASSOC))
		{
			$llista = $llista.",'".$row['usuari']."'";
		}
	} 
	//echo $llista;
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR1').')';
	//echo $e->getMessage();
	return 0; 
}

$km1 = 0.00900009;	// Aproximaci d'un km a graus

$lat1 = $_GET[lat]-($km1*$_GET[distancia]);
$lat2 = $_GET[lat]+($km1*$_GET[distancia]);

$lon1 = $_GET[lon]-($km1*$_GET[distancia]);
$lon2 = $_GET[lon]+($km1*$_GET[distancia]);

$pmin = $_GET[pmin];	// PREUS
$pmax = $_GET[pmax];

if($pmin==0)$pmin=0;
if($pmax==0)$pmax=100;

$carburant = $_GET[carburant];
if($carburant==0)$carburant='';
$carburant = "%".$carburant."%";
$WHERE = ' WHERE lat>:lat1 AND lat<:lat2 AND lon>:lon1 AND lon<:lon2 AND preulitre >= :pmin AND preulitre <= :pmax AND carburant like :carburant ';

// CERQUEM BENZINERES d'USUARIS PUBLICS O DELS USUARIS DE QUI SOM AMICS
$sql = "select b.id, b.lat, b.lon, a.carburant, max(preulitre) as maxp, min(preulitre) as minp from benzinator.benzineres as b ".
	   "INNER JOIN benzinator.abastiments as a on b.id=a.idbenzinera ".
	   "INNER JOIN benzinator.usuariregistrat as u on a.usuari=u.usuari ".$WHERE.
	" AND ((a.usuari, a.id) IN (SELECT z.usuari,max(z.id) FROM benzinator.abastiments as z group by z.usuari,z.idbenzinera)) AND (u.perfil=3 OR u.usuari IN (".$llista.")) GROUP BY b.id, b.lat, b.lon, a.carburant";
//echo $sql;
try {
	$stmt = $dbh->prepare($sql);
	$stmt->bindParam("pmin", $pmin);
	$stmt->bindParam("pmax", $pmax);
	$stmt->bindParam("carburant", $carburant);
	$stmt->bindParam("lat1", $lat1);
	$stmt->bindParam("lat2", $lat2);
	$stmt->bindParam("lon1", $lon1);
	$stmt->bindParam("lon2", $lon2);  
	$stmt->execute();
	$benzineres = $stmt->fetchAll(PDO::FETCH_OBJ);
	$dbh = null;
	echo $_GET['callback'].'({"benzineres":'. json_encode($benzineres).'})';
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR').')';
	echo '{"error":{"text":'. $e->getMessage() .'}}'; 
}

?>