<?php
include 'config.php';

if($_GET[usuari]=='' || $_GET[pwd]==''){echo $_GET['callback'].'('.json_encode('NO').')';return 0; }

$sql = "select usuari from benzinator.usuariregistrat where usuari=:usuari AND password=:pwd";

try {
	$dbh = new PDO("mysql:host=$dbhost;dbname=$dbname", $dbuser, $dbpass);	
	$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$stmt = $dbh->prepare($sql);  
	$stmt->bindParam("usuari", $_GET[usuari]);
	$stmt->bindParam("pwd", $_GET[pwd]);
	$stmt->execute();
	$conta = $stmt->rowCount();
	if($conta == 0){
		echo $_GET['callback'].'('.json_encode('NO').')';
		return 0;
	} 
} catch(PDOException $e) {
	echo $_GET['callback'].'('.json_encode('ERROR1').')';
	return 0; 
}

if($_GET[esborra]=="VEHICLE"){
	try {
		$sql = "delete FROM benzinator.vehicles where usuari=:usuari AND id NOT IN (".$_GET[llista].")";
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);  
		$stmt->execute();
		echo $_GET['callback'].'('.json_encode('OK').')';
		return 0;
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERROR2').')';
		return 0;  
	}
}

if($_GET[esborra]=="ABAST"){
	try {
		$sql = "delete FROM benzinator.abastiments where usuari=:usuari AND id NOT IN (".$_GET[llista].")";
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);  
		$stmt->execute();
		echo $_GET['callback'].'('.json_encode('OK').')';
		return 0;
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERROR3').')';
		return 0;  
	}
}

if($_GET[taula]=="VEHICLE"){
	
	try{
		$sql = "delete from benzinator.vehicles WHERE usuari=:usuari AND id=:id";
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("id", $_GET[id]);
		$stmt->execute();
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERRORSQL1').')';
		return 0;  
	}
		
		
	$sql = "insert into benzinator.vehicles (usuari, id, nom, marca, model, carburant, mitjaconsum) VALUES(:usuari, :id, :nom, :marca, :model, :carburant, :mitjaconsum )";
	
	try {
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("id", $_GET[id]);
		$stmt->bindParam("nom", $_GET[nom]);
		$stmt->bindParam("marca", $_GET[marca]);
		$stmt->bindParam("model", $_GET[model]);
		$stmt->bindParam("carburant", $_GET[carburant]);
		
		if($_GET[mitjaconsum]=="null"){
			$cero=0;   
			$stmt->bindParam("mitjaconsum", $cero);
		}else{
			$stmt->bindParam("mitjaconsum", $_GET[mitjaconsum]);
		}
		//echo $_GET['callback'].'('.json_encode($_GET[id]).')';return 0;
		$stmt->execute();
		echo $_GET['callback'].'('.json_encode($_GET[id]).')';
		return 0;
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERRORSQL2').')';
		return 0;  
	}
}

if($_GET[taula]=="ABAST"){
	$idbenzinera = 0;
	
	if($_GET[lat]!=999){ // lat = 999 vol dir que no s'ha identificat una benzinera
	
	$lat1 = $_GET[lat]-0.000449;
    $lat2 = $_GET[lat]+0.000449;
    
    $lon1 = $_GET[lon]-0.000449;
    $lon2 = $_GET[lon]+0.000449;
    
	// Primer busquem la benzinera
	$sql = "select id from benzinator.benzineres WHERE lat>:lat1 AND lat<:lat2 AND lon>:lon1 AND lon<:lon2 ";
	
	try {
		$stmt = $dbh->prepare($sql);  
		$stmt->bindParam("lat1", $lat1);
		$stmt->bindParam("lat2", $lat2);
		$stmt->bindParam("lon1", $lon1);
		$stmt->bindParam("lon2", $lon2);
		$stmt->execute();
		$conta = $stmt->rowCount();
		if($conta == 0){
			// Si no la trobem la creem
			$sql = "insert into benzinator.benzineres (lat,lon,alt) VALUES (:lat,:lon,0)";
			$stmt = $dbh->prepare($sql);  
			$stmt->bindParam("lat", $_GET[lat]);
			$stmt->bindParam("lon", $_GET[lon]);
			$stmt->execute();
			$idbenzinera = $dbh->lastInsertId();
			//echo $_GET['callback'].'1('.json_encode($idbenzinera).')';return 0;
		} else {
			// Obtenim el ID
			$row = $stmt->fetch(PDO::FETCH_ASSOC);
			$idbenzinera = $row['id'];
			//echo $_GET['callback'].'2('.json_encode($idbenzinera).')';return 0;
		}
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERROR1').')';
		//echo $e->getMessage();
		return 0; 
	}
	}
	// Amb el id de la benzinera creem l'abastiment
	
	try{
		$sql = "delete from benzinator.abastiments WHERE usuari=:usuari AND id=:id";
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("id", $_GET[id]);
		$stmt->execute();
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERRORSQL1').')';
		return 0;  
	}
		
		
	$sql = "insert into benzinator.abastiments (usuari, id, idbenzinera, carburant, valoracio, comentaris, preulitre) VALUES(:usuari, :id, :idbenzinera, :carburant, :valoracio, :comentaris, :preulitre )";
	
	try {
		$stmt = $dbh->prepare($sql);
		$stmt->bindParam("idbenzinera", $idbenzinera);
		$stmt->bindParam("usuari", $_GET[usuari]);
		$stmt->bindParam("id", $_GET[id]);
		$stmt->bindParam("carburant", $_GET[carburant]);
		
		if($_GET[valoracio]=="null"){
			$cero=0;   
			$stmt->bindParam("valoracio", $cero);
		}else{
			$stmt->bindParam("valoracio", $_GET[valoracio]);
		}
		
		if($_GET[comentaris]=="null"){
			$cero='';   
			$stmt->bindParam("comentaris", $cero);
		}else{
			$stmt->bindParam("comentaris", $_GET[comentaris]);
		}
		
		
		if($_GET[preulitre]=="null"){
			$cero=0;   
			$stmt->bindParam("preulitre", $cero);
		}else{
			$stmt->bindParam("preulitre", $_GET[preulitre]);
		}
		//echo $_GET['callback'].'('.json_encode($_GET[id]).')';return 0;
		$stmt->execute();
		echo $_GET['callback'].'('.json_encode($_GET[id]).')';
		return 0;
	} catch(PDOException $e) {
		echo $_GET['callback'].'('.json_encode('ERRORSQL3').')';
		echo $e->getMessage();
		return 0;  
	}
}


echo $_GET['callback'].'('.json_encode('ERROR').')';
  


?>